/// <reference types="node" />
import * as dgram from "dgram";
import { EventEmitter } from "events";
import { Logger } from "../shared/Logger";
export interface StatsdReceiverConfiguration {
    logger: Logger;
}
export declare class StatsdReceiver extends EventEmitter {
    private socket;
    private logger;
    constructor(config: StatsdReceiverConfiguration);
    start(): Promise<dgram.Socket>;
    private handleMessage(msg, rinfo);
    private parseMetricGracefully(line);
    private parseMetric(line);
    private parseNamespace(namespace);
    private parseStat(stat);
}
